# WRJoy - Project file
# Warthog Robotics
# University of Sao Paulo
# https://www.wr.sc.usp.br
# Copyright 2011-2020 Warthog Robotics
# This file is part of WRJoy project


# WRJoy is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# WRJoy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


# Application info
TEMPLATE = app
DESTDIR  = bin
TARGET   = WRJoy
VERSION  = 1.1.2
CONFIG  += c++11

# Qt config
CONFIG += console
CONFIG -= app_bundle
QT     += core gui widgets serialport

# Compilation flags
count(custom_cxxflags, 0) {
    QMAKE_CXXFLAGS_RELEASE = -O2 -Wfloat-equal -Wshadow -Woverloaded-virtual -Wold-style-cast

    count(arch, 1) {
        QMAKE_CXXFLAGS_RELEASE += -march=$$arch
    }
}

# Libraries
LIBS += -lGEARSystem -lomniORB4 -lomnithread -lSDL2

# Temporary dirs
OBJECTS_DIR = tmp/obj
MOC_DIR     = tmp/moc
UI_DIR      = tmp/moc
RCC_DIR     = tmp/rc

# Source files
INCLUDEPATH *= include

HEADERS     += include/WRJoy/wrjoy.hh \
               include/WRJoy/namespace.hh \
               include/WRJoy/joystick.hh \
               include/WRJoy/JoystickGUI/joystickgui.hh \
               include/WRJoy/JoystickGUI/basicsettings.hh \
               include/WRJoy/JoystickGUI/buttonssettings.hh \
               include/WRJoy/JoystickGUI/monitor.hh \
               include/WRJoy/JoystickGUI/advancedsettings.hh \
               include/WRJoy/joystickmanager.hh \
               include/WRJoy/JoystickManagerGUI/joystickmanagergui.hh \
               include/WRJoy/JoystickGUI/playersettings.hh \
               include/exithandler.hh

SOURCES     += src/WRJoy/joystick.cc \
               src/WRJoy/JoystickGUI/joystickgui.cc \
               src/WRJoy/JoystickGUI/basicsettings.cc \
               src/WRJoy/JoystickGUI/buttonssettings.cc \
               src/WRJoy/JoystickGUI/monitor.cc \
               src/WRJoy/JoystickGUI/advancedsettings.cc \
               src/WRJoy/joystickmanager.cc \
               src/WRJoy/JoystickManagerGUI/joystickmanagergui.cc \
               src/main.cc \
               src/WRJoy/JoystickGUI/playersettings.cc \
               src/exithandler.cc

RESOURCES   += img/wrjoy.qrc

DISTFILES   += pre-build.sh \
               LICENSE

# Installation path
bin_files.files = bin/WRJoy

count(bin_path, 0) {
    bin_files.path = /usr/bin/
}

count(bin_path, 1) {
    bin_files.path = $$bin_path
}


INSTALLS += bin_files
