/***
 * Warthog Robotics
 * University of Sao Paulo (USP) at Sao Carlos
 * http://www.warthog.sc.usp.br/
 *
 * This file is part of WRJoy project.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ***/

// Includes WRJoy
#include <WRJoy/wrjoy.hh>
#include "exithandler.hh"

// Includes Qt library
#include <QtCore/QtCore>
#include <QtWidgets/QtWidgets>

// Selects WRJoy namespace
using namespace WRJoy;

int main(int argc, char** argv) {
    QApplication app(argc, argv);
    app.setApplicationName("WRJoy");

    ExitHandler::setup(&app);

    Joystick joy(QString::fromUtf8("Joy0"), true);
    joy.widget()->show();

    int error = app.exec();

    return(error);
}
